{
Unrar.Dll Dynamic Wrapper Component by Rogier Timmermans
------------------------------------
email: MagicRT@hotmail.com
HomePage: http://www.rtimmermans.net 
             - or-
HomePage: http://rtimmermans.webjump.com
------------------------------------

version : 0.2a.X

changes since v0.1 :
------------------------------

v0.1a)
- property ErrorOnDirExists : set to false to ignore "create error" events, when a directory already exists.
                              Files will still generate the error. Default=False (So the default setting is to ignore existing directories !);

v01.b)
- UnRar.Dll can now have ANY name, could be usefull for temp. file generation...

v0.1c)
- Fixed v0.1b ; any name feature is now available; I uploaded the old source-file, that one only had some of the test code in
  there; this new version now has a property for the name, and, it's used in the extract-function as well now.
  Sorry for this little mistake...

v0.1d)
- Intermediate Release;
  - New "Functions" ;
    - ListArchive; Lists contenst of an archive...  // note : experimental, but working !
    - TestArchvie; Tests All files from an archive  // note : experimental, yet untested !

v0.1d.X)
- Experimental Release;
  - Preliminary support for Password protected and MultiVolume archives...
  Note : I need to test that stuff... Everything looks ok; but you never know...
  if any problems arise; let me know !

v0.1d.X2)
- Experimental Release #2;
  - A small change, OnProgress handler in now checked for Assignment before being set...it wasn't checked before; it was assumed to be always present...it caused no problems though...
  - I received reports that the multivolume stuff and password stuff is functional; but as yet still untested by me...
    (I've been mighty busy during this vacation, in fact, i'm busier in these last few weeks than during this entire year at school !) !
  - I've added support for comments, they're now read, and there's a new event related to them, so you can do processing of the comment there...
    Once again, no testing, but i'm sure it will work...

v0.2X)
- Experimental Release (the new stuff is tested, the old experimental stuff is still untested)
 - Support for "single file" processing, as requested by the Author of QuickZip (Http://www.qkzip.net)
   - Both Extract & Test Functions can now either use a stringlist containing the files to extract
    (you can get those by listing the archive first using the list function)
    or simply do "all files" by clearing the filelist...

v0.2a.X)
- One day later...I decided that I needed a file-checking function to see if a file actually is a RAR file...
  well, 20 minutes later, it's there and kicking ass...
  My Ace Wrapper will get the same stuff as well...

}


unit RTdunRar;

interface
uses messages, windows, sysutils, dialogs, classes;

const
UnPack_UnRarDllNotLoaded =-101;
Unpack_ReadErr =101;
UnPack_OK =100;
UnPack_Opened=0;
UnPack_Stopped=255;

const
  rMaxCommentSize = 65535; {Modify this to change the limit of Comment size}

  erEndArchive    = 10; {End of archive} {Finished !}
  erNoMemory      = 11; {Not enough memory to initialize data structures} {This one bites, hopefully you'll never meet this one, i haven't yet...}
  erBadData       = 12; {Archive header broken} {Speaks for itself}
  erBadArchive    = 13; {File is not valid RAR archive} {same here}
  erUnknownFormat = 14; {UnKnown comment format} {i don't process comments, so i haven't seen it yet}
  erEOpen         = 15; {File open error}
  erECreate       = 16; {File create error} {File/dir already exists, or, due to a bug in the Dll, when dir exists, it also generates this}
  erEClose        = 17; {File close error}
  erERead         = 18; {Read error}
  erEWrite        = 19; {Write error}
  erSmallBuf      = 20; {Buffer too small, comments weren't read completely}

  opList          =  0; {Open archive for reading file headers only}
  opExtract       =  1; {Open archive for testing and extracting files}

  doSkip          =  0; {Move to the next file in archive}
                        {Warning: If the archive is solid and opExtract mode                                  was set when the archive was opened, the
                                  current file will be processed - the operation
                                  will be performed slower than a simple seek}
  doTest          =  1; {Test the current file and move to the next file in
                         the archive. If the archive was opened with opList mode,
                         the operation is equal to doSkip}
  doExtract       =  2; {Extract the current file and move to the next file.
                         If the archive was opened with opList mode,
                         the operation is equal to doSkip}

  moVolAsk        =  0; {Required volume is absent. The function should prompt
                         user and return non-zero value to retry the operation.
                         The function may also specify a new volume name,
                         placing it to ArcName parameter}
                         {!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!}
  moVolNotify     =  1; {Required volume is successfully opened. This is a
                         notification call and ArcName modification is NOT
                         allowed. The funciton should return non-zero value
                         to continue or a zero value to terminate operation}
                         {!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!}

type
    TRARHeaderData = record
                    ArcName                            : array[1..260] of char;
                    FileName                           : array[1..260] of char;
                    Flags                              : Cardinal;
                    PackSize                           : Cardinal;
                    UnpSize                            : Cardinal;
                    HostOS                             : Cardinal;
                    FileCRC                            : Cardinal;
                    FileTime                           : Cardinal;
                    UnpVer                             : Cardinal;
                    Method                             : Cardinal;
                    FileAttr                           : Cardinal;
                    CmtBuf                             : PChar;
                    CmtBufSize, CmtSize, CmtState      : Cardinal;
                  end;

  TRAROpenArchiveData = record
                         ArcName                       : PChar;
                         OpenMode                      : Cardinal;
                         OpenResult                    : Cardinal;
                         CmtBuf                        : PChar;
                         CmtBufSize                    : Cardinal;
                         CmtSize                       : Cardinal;
                         CmtState                      : Cardinal;
                       end;

  TComment = record
               Size : Integer;
               Data : Array[1..rMaxCommentSize] of Char;
             end;

TChangeVolProc      = function (var ArcName : PChar; Mode : Integer) : Integer; cdecl;
TProcessDataProc    = function (Addr : PChar; Size : Integer) : Integer; cdecl;

// these vars will hold our functions from the dll...
var RAROpenArchive : function (var ArchiveData : TRAROpenArchiveData) : THandle; stdcall;
var RARCloseArchive: function (hArcData : THandle) : Integer; stdcall;
var RARReadHeader  : function (hArcData : THandle; var HeaderData : TRARHeaderData) : Integer; stdcall;
var RARProcessFile : function  (hArcData : THandle; Operation : Integer; DestPath, DestName : PChar) : Integer; stdcall;
var RARSetProcessDataProc: procedure (hArcData : THandle; PDP : TProcessDataProc); stdcall;

var RARSetChangeVolProc  : procedure (hArcData : THandle; CVP : TChangeVolProc); stdcall;
var RARSetPassword       : procedure (hArcData : THandle; Password : PChar); stdcall;

type TErrorProc          = procedure (Sender: TObject; Error : Integer) of object;
     TFileBeingExtracted = procedure (Sender: TObject; eFile : TRARHeaderData) of object;
     TFileBeingListed    = procedure (Sender: TObject; eFile : TRARHeaderData) of object;
     TFileBeingTested    = procedure (Sender: TObject; eFile : TRARHeaderData) of object;
     TFileExtracted      = procedure (Sender: TObject; eFile : TRARHeaderData; Result : Boolean) of object;
     TFileListed         = procedure (Sender: TObject; eFile : TRARHeaderData; Result : Boolean) of object;
     TFileTested         = procedure (Sender: TObject; eFile : TRARHeaderData; Result : Boolean) of object;
     TProcessDataProcN   = function (Sender: TObject; Addr : PChar; BlockSize, Position : Integer) : Integer of object;

     TChangeVolProcN     = function (Sender: TObject; ArcName : PChar; Mode : Integer) : Integer of object;
     TReqPassword        = procedure (Sender: TObject; eFile : TRARHeaderData; var Password : String) of object;

     TCommentProc        = procedure (Sender: TObject; Comment : TComment) of object;



Type TdRar=class(TComponent)
   private
     FArchive_file              : string;
     FTarget_dir                : string;
     FUnRarDllPath              : string;
     FUnRarDllName              : string;

     FError                     : TErrorProc;
     FComment                   : TCommentProc;
     FFileExtracted             : TFileExtracted;
     FFileBeingExtracted        : TFileBeingExtracted;
     FOnProgress                : TProcessDataProcN;

     FStop                      : Boolean;
     FErrorOnDirExists          : Boolean;

     FActualPos                 : Integer;

// experimental
     FFileListed             : TFileListed; // file  is about to be be listed
     FFileBeingListed        : TFileBeingListed; // the file currently being listed
     FFileTested             : TFileTested; // file that is about to be tested
     FFileBeingTested        : TFileBeingTested;  // the file currently being tested

     FChngVolume             : TChangeVolProcN; // your change volume procedure...
     FReqPassword            : TReqPassword; // your request PW procedure...

     FFilesToProcess            : TStringList;
     procedure SetFilesToProcess(Value : TStringList);

   protected
   // nothing here...
   public
    constructor Create(AOwner : TComponent); override;
    destructor Free;
    Function GetRarErrorString(Error : Integer) : String;

    Function ExtractArchive:integer;
    Function ListArchive:integer;
    Function TestArchive:integer;
    Function ValidateArchive:integer;

   published
    property Archivefilename : string
      read FArchive_file write FArchive_file;
    property TargetDirectory : string
      read FTarget_Dir write FTarget_Dir;
    property Path2UnrarDll : string
      read FUnRarDllPath write FUnRarDllPath;
    property NameofUnrarDll : string
      read FUnRarDllName write FUnRarDllName;

    property Stop : Boolean
      read FStop write FStop default False;

    property ErrorOnDirExists : Boolean
     read FErrorOnDirExists write FErrorOnDirExists default False;

    property OnError : TErrorProc
      read FError write FError;
    property OnExtracting : TFileBeingExtracted
      read FFileBeingExtracted write FFileBeingExtracted;
    property OnExtract : TFileExtracted
      read FFileExtracted write FFileExtracted;
    property OnProcessData : TProcessDataProcN
      read FOnProgress write FOnProgress;

// experimental stuff

    property OnListing : TFileBeingListed
      read FFileBeingListed write FFileBeingListed;
    property OnList : TFileListed
      read FFileListed write FFileListed;

    property OnTesting : TFileBeingTested
      read FFileBeingTested write FFileBeingTested;
    property OnTest : TFileTested
      read FFileTested write FFileTested;

    property OnVolumeChange : TChangeVolProcN
      read FChngVolume write FChngVolume;

    property OnReqPassword : TReqPassword
      read FReqPassword write FReqPassword;

    property OnComment : TCommentProc
      read FComment write FComment;

    property FilesToProcess : TStringList
      read FFilesToProcess write SetFilesToProcess;

 end;

procedure Register;

implementation

procedure Register;
begin
  RegisterComponents('Rogier Timmermans'' Components', [TdRAR]);
end;

//const
var  RarDllHandle:thandle=0;
//const
var UnRarHandle:thandle=0;

Function LoadRarDLL (const dllpath:string; const dllname:string) :boolean;
var DlPath, dlname:String;
var pt:pchar;
var oldmode:integer;
begin
  if RtdunRar.RarDllHandle<>0 then result:=true
  else begin
    if (dllpath[length(dllpath)]<>'\') then dlpath:=dllpath+'\'
      else dlpath:=dllpath; {path with \ or without... add a \ if there isn't one...}

   if dllname='' then dlname:='unrar.dll' else dlname:=dllname;
    pt:=pchar(dlpath+dlname); {now cast it}
    oldmode:=SetErrorMode($8001);
    RtdunRar.RarDllHandle:=LoadLibrary(pt);
    SetErrorMode(oldmode);
    if RtdunRar.RarDllHandle<>0 then begin
      @RAROpenArchive:=GetProcAddress(RtdunRar.RarDllHandle,'RAROpenArchive');
      @RARCloseArchive:=GetProcAddress(RtdunRar.RarDllHandle,'RARCloseArchive');
      @RARReadHeader:=GetProcAddress(RtdunRar.RarDllHandle,'RARReadHeader');
      @RARProcessFile:=GetProcAddress(RtdunRar.RarDllHandle,'RARProcessFile');
      @RARSetProcessDataProc:=GetProcAddress(RtdunRar.RarDllHandle,'RARSetProcessDataProc');

      @RARSetChangeVolProc:=GetProcAddress(RtdunRar.RarDllHandle,'RARSetChangeVolProc');
      @RARSetPassword:=GetProcAddress(RtdunRar.RarDllHandle,'RARSetPassword');

      if (@RarOpenArchive=nil) or (@RarCloseArchive=nil) or (@RarReadHeader=nil) or
         (@RarProcessFile=nil) or (@RarSetProcessDataProc=nil)
         or (@RARSetPassword=nil) or (@RARSetChangeVolProc=nil)
      then begin
        FreeLibrary(RtdunRar.RarDllHandle);
        RtdunRar.RarDllHandle:=0;
      end;
    end;
    result:=RtdunRar.RarDllHandle<>0;
  end;
end;

Procedure UnloadRarDll;
begin
  if RtdunRar.RarDllHandle<>0 then
    FreeLibrary(RtdunRar.RarDllHandle);
  RtdunRar.RarDllHandle:=0;
end;

procedure CloseRARfile;
begin
  if RtdunRar.unRARhandle<>0 then
    RARCloseArchive(RtdunRar.unRARhandle);
  RtdunRar.unRARhandle:=0;
end;

Function TdRar.GetRarErrorString(Error : Integer) : String;
begin
  case Error of
    UnPack_UnRarDllNotLoaded : Result:='Unable to load Unrar.Dll...';
    erEndArchive, UnPack_OK : Result:='End of archive, All Done !';
    erNoMemory      : Result:='Not enough memory to initialize data structures';
    erBadData       : Result:='CRC error, data damaged';
    erBadArchive    : Result:='File is not a valid RAR archive';
    erUnknownFormat : Result:='Unknown comment format';
    erEOpen         : Result:='File open error';
    erECreate       : Result:='File create error, either a ReadOnly-File or a directory that already exists...';
    erEClose        : Result:='File close error';
    erERead,Unpack_ReadErr : Result:='Read error';
    erEWrite        : Result:='Write error';
    erSmallBuf      : Result:='Buffer is too small for comment';
    UnPack_Stopped : Result:='Decompression Canceled by user !';
    else Result:='Unknown error !'+#13+'Code :'+inttostr(Error);
  end;
end;

constructor TdRAR.Create(AOwner : TComponent);
begin
  inherited Create(AOwner);
  FFilesToProcess:=TStringList.Create;
  FFilesToProcess.Sorted:=True;
  FUnRarDllName:='unrar.dll';
end;

destructor TdRAR.Free;
begin
  FFilesToProcess.Free;
  inherited free;
end;

var xSelf:Pointer;


procedure TdRAR.SetFilesToProcess(Value : TStringList);
begin
  FFilesToProcess.Assign(Value);
end;


Function ProcessDataProc(Addr : PChar; Size : Integer) : Integer; cdecl;
Begin
  TdRAR(xSelf).FActualPos:=(TdRAR(xSelf).FActualPos+Size);
  Result:=TdRAR(xSelf).OnProcessData(xSelf,Addr,Size,TdRAR(xSelf).FActualPos);
end;

Function ChangeVolProc(var ArcName : PChar; Mode : Integer) : Integer; cdecl;
Begin
  Result:=TdRAR(xSelf).OnVolumeChange(xSelf,ArcName,Mode);
end;


Function Tdrar.ExtractArchive:integer;
var RAROpenArchiveData:TRAROpenArchiveData;
    RARHeaderData:TRARHeaderData;
    err,res,temp:integer;
    Extractdone:boolean;
    s,Password:string;
    Comm : TComment;

Begin
  xSelf:=Self;
  if (not LoadRARDll(Path2UnRarDll, NameofUnrarDll)) then
                                      begin
                                        if Assigned(onError) then OnError(Self,UnPack_UnRarDllNotLoaded);
                                        result:=UnPack_UnRarDllNotLoaded;
                                        exit;
                                       end;
  if unRARhandle=0 then begin  {open first!}
    fillchar(RAROpenArchiveData, sizeof(tRAROpenArchiveData),#0); {Clear it, just to make sure !}
    with RAROpenArchiveData do
      begin
        ArcName:=pchar(FArchive_file); {Set the Archive File}
        OpenMode:=OpEXTRACT; {Set the open-mode}
        // 2 new lines for comment support...
        CmtBuf:=@Comm.Data[1];
        CmtBufSize:=SizeOf(Comm.Data);
       end;
    unRARhandle:=RAROpenArchive(RAROpenArchiveData); {Now open the Archive and gobble up some memory}

    // new line for comment support...
    Comm.Size:=RAROpenArchiveData.CmtSize;

    case RAROpenArchiveData.OpenResult of {What did opening report ?}
      0: begin Res:=unPack_opened; end; {openend}
      erBadData : begin res:=erBadData;if Assigned(OnError) then OnError(Self,RarOpenArchiveData.OpenResult); end;
      erBadArchive: begin res:=erBadArchive;if Assigned(OnError) then OnError(Self,RarOpenArchiveData.OpenResult);end;
     else
      begin res:=unPack_ReadErr;if Assigned(OnError) then OnError(Self,RarOpenArchiveData.OpenResult);end;
    end;

    if (res<>unpack_opened) then begin {if not opened ok, bail !}
                                if Assigned(OnError) then OnError(Self,Res);
                                Result:=Res;
                                CloseRARfile;
                                UnloadRarDll;
                                Exit;
                               end;

    // experimental lines...
    if Assigned(OnVolumeChange) then RARSetChangeVolProc(unRARhandle,ChangeVolProc);  {Set the DiskChanging procedure}
    if Assigned(OnComment) then OnComment(Self,Comm); {Set User Comment handler routine}

    RARHeaderData.CmtBuf:=@Comm.Data[1];
    RARHeaderData.CmtBufSize:=SizeOf(Comm.Data);

    if Assigned(OnProcessData) then RARSetProcessDataProc(unRARhandle,@ProcessDataProc); {Set the processing procedure}

  end else
    result:=unpack_opened;
  fillchar(RARHeaderData,sizeof(TRARHeaderData),#0); // fill with 0 to make sure it's clean

  extractdone:=false; // we're not done
  repeat
     err:=RARReadHeader(unRARhandle,RARHeaderData);
     if FStop then // stop pressed, now clean up & exit
      begin
        CloseRarFile;
        UnloadRarDll;
        err:=UnPack_Stopped;
        Result:=Err;
        FStop:=False;
        Exit;
      end;
    if err<>0 then // something went wrong, so notify user...
       begin
         if Assigned(OnError) then OnError(Self, err);
         result:=Err;
         CloseRARfile;
         UnloadRarDll;
         exit;
        end;
      S:='';
        for Temp:=1 to SizeOf(RarHeaderData.FileName) do
          if RarHeaderData.FileName[Temp]=#00 then break
           else S:=S+RarHeaderData.FileName[Temp]; // get filename from RarHeader
      if Assigned(OnExtracting) then OnExtracting(Self, RarHeaderData);
      FActualPos:=0;


   if (FFilesToProcess.Count=0) or (FFilesToProcess.Find(S,Temp)) then // extract file or just all
      begin
         // preliminary password support...begin
         if ((RarHeaderData.Flags and 4)=4) and (Assigned(OnReqPassword)) then
            begin
              OnReqPassword(Self,RarHeaderData,Password);
              if Password<>'' then RARSetPassword(unRARhandle,@Password[1]);
             end;
         // preliminary password support...end
        err:=RARProcessFile(unRARhandle,doEXTRACT,pchar(Targetdirectory),nil);
        if (FErrorOnDirExists=false) and (err =erECreate) and (RarHeaderData.Flags and 128=128) and (RarHeaderData.Flags and 64=64)and (RarHeaderData.Flags and 32=32)then err:=0; // ignore "dir-create" error if it already existed
        if Assigned(OnExtract) then OnExtract(Self, RarHeaderData, (err=0));
       end
      else
       begin
           err:=RARProcessFile(unRARhandle,doSKIP,nil,nil);
         end;

    if err<>0 then begin
      If Assigned(OnError) then OnError(Self,err); // insert your extensions here...
      if (err in [erEndArchive, UnPack_Stopped]) then result:=Unpack_Stopped else result:=err;
      extractdone:=true;
    end;
  until extractdone;
  CloseRARfile; // make sure we return the memory we gobbled up; if it's already gone, this won't do a thing...
  UnloadRarDll; // make sure we get rid of the Dll ; if it's already gone, it doesn't do anything
end;



Function Tdrar.ListArchive:integer;
var RAROpenArchiveData:TRAROpenArchiveData;
    RARHeaderData:TRARHeaderData;
    err,res,temp:integer;
    s,Password:string;
    ListDone:boolean;
    Comm : TComment;
begin
  xSelf:=Self;
  if (not LoadRARDll(Path2UnRarDll, NameofUnrarDll)) then
                                      begin
                                        if Assigned(onError) then OnError(Self,UnPack_UnRarDllNotLoaded);
                                        result:=UnPack_UnRarDllNotLoaded;
                                        exit;
                                       end;
  if unRARhandle=0 then begin  {open first!}
    fillchar(RAROpenArchiveData, sizeof(tRAROpenArchiveData),#0); {Clear it, just to make sure !}
    with RAROpenArchiveData do
      begin
        ArcName:=pchar(FArchive_file);        {Set the Archive File}
        OpenMode:=OpLIST;     {Set the open-mode; we're listing the archive !}
        // 2 new lines for comment support...
        CmtBuf:=@Comm.Data[1];
        CmtBufSize:=SizeOf(Comm.Data);
       end;
    unRARhandle:=RAROpenArchive(RAROpenArchiveData); {Now open the Archive and gobble up some memory}

    // new line for comment support...
    Comm.Size:=RAROpenArchiveData.CmtSize;


    case RAROpenArchiveData.OpenResult of {What did opening report ?}
      0: begin Res:=unPack_opened; end; {openend}
      erBadData : begin res:=erBadData;if Assigned(OnError) then OnError(Self,RarOpenArchiveData.OpenResult); end;
      erBadArchive: begin res:=erBadArchive;if Assigned(OnError) then OnError(Self,RarOpenArchiveData.OpenResult);end;
     else
      begin res:=unPack_ReadErr;if Assigned(OnError) then OnError(Self,RarOpenArchiveData.OpenResult);end;
    end;

    if (res<>unpack_opened) then begin {if not opened ok, bail !}
                                if Assigned(OnError) then OnError(Self,Res);
                                Result:=Res;
                                CloseRARfile;
                                UnloadRarDll;
                                Exit;
                               end;
    // experimental lines...
    if Assigned(OnVolumeChange) then RARSetChangeVolProc(unRARhandle,ChangeVolProc);  {Set the DiskChanging procedure}
    if Assigned(OnComment) then OnComment(Self,Comm); {Set User Comment handler routine}

    RARHeaderData.CmtBuf:=@Comm.Data[1];
    RARHeaderData.CmtBufSize:=SizeOf(Comm.Data);

    if Assigned(OnProcessData) then RARSetProcessDataProc(unRARhandle,@ProcessDataProc); {Set the processing procedure}
  end else
    result:=unpack_opened;
  fillchar(RARHeaderData,sizeof(TRARHeaderData),#0); // fill with 0 to make sure it's clean

  Listdone:=false; // we're not done
  repeat
     err:=RARReadHeader(unRARhandle,RARHeaderData);
     if FStop then // stop pressed, now clean up & exit
      begin
        CloseRarFile;
        UnloadRarDll;
        err:=UnPack_Stopped;
        Result:=Err;
        FStop:=False;
        Exit;
      end;
    if err<>0 then // something went wrong, so notify user and clean up...
       begin
         if Assigned(OnError) then OnError(Self, err);
         result:=Err;
         CloseRARfile;
         UnloadRarDll;
         exit;
        end;
      S:='';
        for Temp:=1 to SizeOf(RarHeaderData.FileName) do
          if RarHeaderData.FileName[Temp]=#00 then break
           else S:=S+RarHeaderData.FileName[Temp]; // get filename from RarHeader
      if Assigned(OnListing) then OnListing(Self, RarHeaderData);
      FActualPos:=0;

      // preliminary password support...begin
     if ((RarHeaderData.Flags and 4)=4) and (Assigned(OnReqPassword)) then
      begin
        OnReqPassword(Self,RarHeaderData,Password);
        if Password<>'' then RARSetPassword(unRARhandle,@Password[1]);
      end;
      // preliminary password support...end

      err:=RARProcessFile(unRARhandle,doSKIP,nil,nil);
      if Assigned(OnList) then OnList(Self, RarHeaderData, (err=0));
    if err<>0 then begin
      If Assigned(OnError) then OnError(Self,err); // insert your extensions here...
      if (err in [erEndArchive, UnPack_Stopped]) then result:=Unpack_Stopped else result:=err;
      Listdone:=true;
    end;
  until Listdone;
  CloseRARfile; // make sure we return the memory we gobbled up; if it's already gone, this won't do a thing...
  UnloadRarDll; // make sure we get rid of the Dll ; if it's already gone, it doesn't do anything
end;

Function Tdrar.TestArchive:integer;
// another experimental function...really untested, so be carefull !!!
var RAROpenArchiveData:TRAROpenArchiveData;
    RARHeaderData:TRARHeaderData;
    err,res,temp:integer;
    Testdone:boolean;
    s,Password:string;
    Comm : TComment;
Begin
  xSelf:=Self;
  if (not LoadRARDll(Path2UnRarDll, NameofUnrarDll)) then
                                      begin
                                        if Assigned(onError) then OnError(Self,UnPack_UnRarDllNotLoaded);
                                        result:=UnPack_UnRarDllNotLoaded;
                                        exit;
                                       end;
  if unRARhandle=0 then begin  {open first!}
    fillchar(RAROpenArchiveData, sizeof(tRAROpenArchiveData),#0); {Clear it, just to make sure !}
    with RAROpenArchiveData do
      begin
        ArcName:=pchar(FArchive_file);        {Set the Archive File}
        OpenMode:=OpEXTRACT;     {Set the open-mode}
        // 2 new lines for comment support...
        CmtBuf:=@Comm.Data[1];
        CmtBufSize:=SizeOf(Comm.Data);
       end;
    unRARhandle:=RAROpenArchive(RAROpenArchiveData); {Now open the Archive and gobble up some memory}

    // new line for comment support...
    Comm.Size:=RAROpenArchiveData.CmtSize;


    case RAROpenArchiveData.OpenResult of {What did opening report ?}
      0: begin Res:=unPack_opened; end; {openend}
      erBadData : begin res:=erBadData;if Assigned(OnError) then OnError(Self,RarOpenArchiveData.OpenResult); end;
      erBadArchive: begin res:=erBadArchive;if Assigned(OnError) then OnError(Self,RarOpenArchiveData.OpenResult);end;
     else
      begin res:=unPack_ReadErr;if Assigned(OnError) then OnError(Self,RarOpenArchiveData.OpenResult);end;
    end;

    if (res<>unpack_opened) then begin {if not opened ok, bail !}
                                if Assigned(OnError) then OnError(Self,Res);
                                Result:=Res;
                                CloseRARfile;
                                UnloadRarDll;
                                Exit;
                               end;

    // experimental line...
    if Assigned(OnVolumeChange) then RARSetChangeVolProc(unRARhandle,ChangeVolProc);  {Set the DiskChanging procedure}
    if Assigned(OnComment) then OnComment(Self,Comm); {Set User Comment handler routine}

    RARHeaderData.CmtBuf:=@Comm.Data[1];
    RARHeaderData.CmtBufSize:=SizeOf(Comm.Data);

    if Assigned(OnProcessData) then RARSetProcessDataProc(unRARhandle,@ProcessDataProc); {Set the processing procedure}
  end else
    result:=unpack_opened;
  fillchar(RARHeaderData,sizeof(TRARHeaderData),#0); // fill with 0 to make sure it's clean

  Testdone:=false; // we're not done
  repeat
     err:=RARReadHeader(unRARhandle,RARHeaderData);
     if FStop then // stop pressed, now clean up & exit
      begin
        CloseRarFile;
        UnloadRarDll;
        err:=UnPack_Stopped;
        Result:=Err;
        FStop:=False;
        Exit;
      end;
    if err<>0 then // something went wrong, so notify user...
       begin
         if Assigned(OnError) then OnError(Self, err);
         result:=Err;
         CloseRARfile;
         UnloadRarDll;
         exit;
        end;
      S:='';
        for Temp:=1 to SizeOf(RarHeaderData.FileName) do
          if RarHeaderData.FileName[Temp]=#00 then break
           else S:=S+RarHeaderData.FileName[Temp]; // get filename from RarHeader
      if Assigned(OnTesting) then OnTesting(Self, RarHeaderData);
      FActualPos:=0;


   if (FFilesToProcess.Count=0) or (FFilesToProcess.Find(S,Temp)) then // extract file or just all
      begin
         // preliminary password support...begin
         if ((RarHeaderData.Flags and 4)=4) and (Assigned(OnReqPassword)) then
            begin
              OnReqPassword(Self,RarHeaderData,Password);
              if Password<>'' then RARSetPassword(unRARhandle,@Password[1]);
             end;
         // preliminary password support...end
        err:=RARProcessFile(unRARhandle,doTEST,nil,nil);

        if Assigned(OnTest) then OnTest(Self, RarHeaderData, (err=0));
       end
      else
       begin
           err:=RARProcessFile(unRARhandle,doSKIP,nil,nil);
         end;

    if err<>0 then begin
      If Assigned(OnError) then OnError(Self,err); // insert your extensions here...
      if (err in [erEndArchive, UnPack_Stopped]) then result:=Unpack_Stopped else result:=err;
      Testdone:=true;
    end;
  until Testdone;
  CloseRARfile; // make sure we return the memory we gobbled up; if it's already gone, this won't do a thing...
  UnloadRarDll; // make sure we get rid of the Dll ; if it's already gone, it doesn't do anything
end;


// new function, determines if a file is a RAR Archive...

Function Tdrar.ValidateArchive:integer;
var RAROpenArchiveData:TRAROpenArchiveData;
Begin
  xSelf:=Self; // point to myself...
  if (not LoadRARDll(Path2UnRarDll, NameofUnrarDll)) then
                                      begin
                                        if Assigned(onError) then OnError(Self,UnPack_UnRarDllNotLoaded);
                                        result:=UnPack_UnRarDllNotLoaded; // possible error...
                                        exit;
                                       end;
  if unRARhandle=0 then begin  {open first!}
    fillchar(RAROpenArchiveData, sizeof(tRAROpenArchiveData),#0); {Clear it, just to make sure !}
    with RAROpenArchiveData do
      begin
        ArcName:=pchar(FArchive_file);        {Set the Archive File}
        OpenMode:=OpLIST;     {Set the open-mode}
       end;
   unRARhandle:=RAROpenArchive(RAROpenArchiveData); {Now open the Archive and gobble up some memory}
   end;
   Result:=RAROpenArchiveData.OpenResult; // return result code....wheter good or bad, we need this anyway...
   CloseRARfile; // make sure we return the memory we gobbled up; if it's already gone, this won't do a thing...
   UnloadRarDll; // make sure we get rid of the Dll ; if it's already gone, it doesn't do anything
end;






end.



